function! s:let(scope, name, value) "{{{
  let global_variable_name = a:scope . ':' . a:name
  if !exists(global_variable_name)
    let cmd = 'let ' . global_variable_name . ' = ' . string( a:value )
    exe cmd
  endif
endfunction"}}}

function! alpaca_complete#system(cmd, path)
  let g:hoge = 'alpaca_complete -c ' . a:cmd . ' -f ' . a:path 
  return neocomplcache#system( 'alpaca_complete -c ' . a:cmd . ' -f ' . a:path )
endfunction

function! alpaca_complete#initialize()
  " Create cache directory.
  if !isdirectory(neocomplcache#get_temporary_directory() . '/alpaca_complete')
    call mkdir(neocomplcache#get_temporary_directory() . '/alpaca_complete')
  endif
endfunction

function! alpaca_complete#rails_root_join(path)
  if alpaca_complete#enable()
    if empty( a:path ) || a:path == '/'
      return b:rails_root
    endif

    let real_path = b:rails_root . '/' . a:path

    return substitute(real_path, '/$', '', 'g')
  endif
endfunction

function! alpaca_complete#let_g:(name, value) "{{{
  call s:let('g', a:name, a:value)
endfunction"}}}

function! alpaca_complete#enable() "{{{
  if exists('b:rails_root')
    return 1
  else
    return 0
  endif
endfunction"}}}
