module AlpacaComplete::Detect

  # program portability from rails.vim
  # return rails root path
  def self.detect(  filename )
    fn = filename.gsub('\c^file://', '')

    if File.readable?("#{fn}/config/environment.rb")
      return fn
    else
      fn = File.dirname(fn)
    end

    # return rails_root_path if filename is config/environment.rb
    if fn =~ /[\/]config[\/]environment\.rb$/
      return fn[0, fn.length - 22]
    end

    ofn = nil
    until fn == ofn || fn == nil do
      return fn if File.readable?("#{fn}/config/environment.rb")

      ofn = fn
      rails_path = ofn.match( /^(.*)[\/](app|config|db|doc|extras|features|lib|log|public|script|spec|stories|test|tmp|vendor|publics|sdoc)($|[\/].*$)/)

      if rails_path
        fn = rails_path[1]
      else
        break
      end
    end

    return nil
  end
end

