# hash extend deep_merge
class Hash
  # Returns a new hash with +self+ and +other_hash+ merged recursively.
  def deep_merge(other_hash)
    dup.deep_merge!(other_hash)
  end

  # Same as +deep_merge+, but modifies +self+.
  def deep_merge!(other_hash)
    other_hash.each_pair do |k,v|
      tv = self[k]
      self[k] = tv.is_a?(Hash) && v.is_a?(Hash) ? tv.deep_merge(v) : v
    end
    self
  end

  def join_keys( str = ".", key="" )
    dup.join_keys! str, key
  end

  def join_keys!( str = ".", key="")
    res = {}
    each do |k, v|
      full_key = key.empty? ?  k : "#{key}#{str}#{k}"
      if v.is_a?(Hash)
        res.deep_merge!( v.join_keys( str, full_key ) )
      else
        res[full_key] = v
      end
    end

    clear
    self.merge! res
  end
end

